<script setup>
import { useToolStore } from '@/stores/useToolStore';

const props = defineProps(['selectedTool', 'buttonTitle'])
const toolStore = useToolStore()
const currentTool = props.selectedTool
const currentDataObjects = ref(null)
const currentDataObject = ref(null)
const currentParent = ref('')
const navigationHistory = ref([])
const spinner = ref(false)
currentDataObjects.value = null
currentParent.value = null
navigationHistory.value.length = 0


onMounted(async () => {
    const data = await toolStore.fetchDataObjects(currentTool)
    currentParent.value = {id: null, name: data.root_name}
    currentDataObjects.value = data.objects
})

const emits = defineEmits(['currentStep', 'usedDataObject'])

function setcurrentStep(step) {
    emits('currentStep', step)
}

function selectDataObject(object) {
    currentDataObject.value = object
}

async function browseDataObject(object) {
    if (object.has_children == true) {
        navigationHistory.value.push(currentParent.value)
        currentParent.value = { id: object.id, name: object.name, type: object.type }
        currentDataObjects.value = null
        currentDataObject.value = object
        const data = await toolStore.fetchDataObjects(currentTool, object)
        currentParent.value.name = object.name
        currentDataObjects.value = data.objects
    }
}

async function browseUp() {
    let object = navigationHistory.value.pop()
    currentDataObjects.value.length = 0
    currentParent.value = { id: object.id, name: object.name, type: object.type }
    const data = await toolStore.fetchDataObjects(currentTool, object.id ? object : null)
    currentDataObjects.value = data.objects
}

async function useDataObject(Dataobject) {
    spinner.value = true;
    emits('usedDataObject', Dataobject)
}
</script>


<template>
<v-col class="d-flex flex-column fill-height">
    <div v-if="currentDataObjects != null">
        <div class="d-flex flex-row align-center">
            <v-btn
                v-if="navigationHistory.length > 0"
                icon="mdi-chevron-up"
                color="black"
                variant="text"
                rounded="0"
                density="compact"
                @click="browseUp()"
            ></v-btn>
            <h4>{{ currentParent.name }}</h4>
        </div>

        <v-divider></v-divider>
    </div>
    <div v-if="currentDataObjects != null" class="overflow-y-auto">
        <DataObjectItem v-for="object in currentDataObjects"
            :object="object"
            :active="currentDataObject && object.id == currentDataObject.id"
            @choose="selectDataObject(object)"
            @open="browseDataObject(object)" />
    </div>
    <div v-if="currentDataObjects == null">
        <div class="skeleton skeleton-text skeleton-title mb-4"></div>
        <div class="skeleton skeleton-text"></div>
        <div class="skeleton skeleton-text"></div>
        <div class="skeleton skeleton-text"></div>
    </div>
    <div class="mt-auto d-flex flex-row">
        <v-btn
            size="small"
            color="primary"
            class="ml-auto"
            @click="setcurrentStep('selectConnector')"
        >Back</v-btn>
        <v-btn v-if="spinner == false"
            size="small"
            color="primary"
            class="ml-5"
            @click="useDataObject(currentDataObject)"
            :disabled="! currentDataObject"
        >{{props.buttonTitle}}</v-btn>
        <v-btn v-if="spinner == true"
            size="small"
            color="primary"
            class="ml-5"
            style= "width:149px;"
            >
            <div class="spinner">
                <div class="bounce1"></div>
                <div class="bounce2"></div>
                <div class="bounce3"></div>
            </div>
        </v-btn>
    </div>
</v-col>
<v-divider class="mx-4" vertical></v-divider>
<v-col cols="3" class="d-flex flex-column fill-height">
    <div class="d-flex flex-row">
        <v-avatar
            rounded="0"
            :image="toolStore.connectors.get(currentTool.connector).icon"
            class="mr-1 align-center"
        ></v-avatar>
        <div>
            <p>{{ toolStore.connectors.get(currentTool.connector).name }}</p>
            <p class="text-subtitle-2">{{ currentTool.name }}</p>
        </div>
    </div>
    <v-card class="mt-12" variant="text" v-if="currentDataObject">
        <v-card-text>
            <div class="mx-auto text-center">
                <v-icon v-if="currentDataObject.icon.includes('fa-')"
                    class="mx-1 my-auto"
                    :icon="'fa: ' + currentDataObject.icon"
                ></v-icon>
                <v-icon v-if="!currentDataObject.icon"
                    class="mx-1 my-auto"
                    :icon="'fa: fas fa-circle-question'"
                ></v-icon>
                <v-img v-if="currentDataObject.icon.toLowerCase().includes('.png', '.jpg', '.jpeg', '.svg')"
                    class="mx-auto my-auto"
                    max-width="20"
                    :src="currentDataObject.icon"
                ></v-img>
                <h4 v-if="currentDataObject.url" class="mt-2">
                    <a :href="currentDataObject.url" target="_blank">{{ currentDataObject.name }}</a>
                </h4>
                <h4 v-else class="mt-2">
                    {{ currentDataObject.name }}
                </h4>

                <p class="text-caption mt-1">
                    {{ currentDataObject.type }}
                </p>
                <br>
                <span v-if="currentDataObject.description" class="clamp"><i>{{ currentDataObject.description}}</i></span>
            </div>
        </v-card-text>
    </v-card>
</v-col>
</template>

<style>
.clamp {
  width: auto;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 10;
  overflow: hidden;
}
</style>
